package org.bench4q.master.unitTest.datastatistics;

import static org.junit.Assert.*;

import java.util.ArrayList;

import org.bench4q.master.domain.valueobject.datastatistics.impl.BehaviorBriefStatistics;
import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;
import org.bench4q.share.models.agent.statistics.BehaviorStatusCodeResultModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorBriefModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorStatusCodeModel;
import org.junit.Test;

public class Test_BehaviorBriefStatistics {

	@Test
	public void test() {
		String url = "www.baidu.com";
		int behaviorId = 1;
		BehaviorBriefStatistics behaviorStatistics = new BehaviorBriefStatistics(
				behaviorId, url);
		behaviorStatistics.add(buildBehaviorBriefModel(behaviorId, url, 2, 3));
		behaviorStatistics.add(buildBehaviorBriefModel(behaviorId, url, 3, 5));
		ScriptBehaviorBriefModel result = (ScriptBehaviorBriefModel) behaviorStatistics
				.getStatistics();
		System.out.println(MarshalHelper.tryMarshal(result));
		assertEquals(5, result.getSuccessCountFromBegin());
		assertEquals(8, result.getTotalCountFromBegin());
		int countForAllDetail = 0;
		for (ScriptBehaviorStatusCodeModel behaviorStatusCodeModel : result
				.getDetailStatusList()) {
			countForAllDetail += behaviorStatusCodeModel.getCount();
		}
		assertEquals(result.getTotalCountFromBegin(), countForAllDetail);
	}

	private BehaviorBriefModel buildBehaviorBriefModel(int behaviorId,
			String url, int successCount, int totalCount) {
		BehaviorBriefModel e = new BehaviorBriefModel();
		e.setBehaviorId(behaviorId);
		e.setBehaviorUrl(url);
		e.setDetailStatusCodeResultModels(new ArrayList<BehaviorStatusCodeResultModel>());
		for (int i = 0; i < successCount; i++) {
			e.getDetailStatusCodeResultModels().add(
					new BehaviorStatusCodeResultModel(1, 200, 1, i + 1,
							"text/html", 320, 10, 190, 260, 450));
		}
		for (int i = 0; i < totalCount - successCount; i++) {
			e.getDetailStatusCodeResultModels().add(
					new BehaviorStatusCodeResultModel(1, 400, 1, successCount
							+ i + 1, "text/html", 320, 10, 190, 260, 450));
		}
		e.setSuccessfulCount(successCount);
		e.setTotalCount(totalCount);
		return e;
	}
}
